#ifndef _BL_H_
#define _BL_H_

#ifdef OLDGCC
/* 
 * a bug in the gcc port -- it doesn't save %a4, as it isn't 
 * supposed to be destroyed; SysTraps() however do this casually;
 * place these macros in EventHandler routines and callback functions.
 *
 * the egcs port doesn't have it anymore :-)
 */
register void *reg_a4 asm("%a4");
#  define CALLBACK_PROLOGUE \
    void *save_a4 = reg_a4; asm("move.l %%a5,%%a4; sub.l #edata,%%a4" : :);
#  define CALLBACK_EPILOGUE reg_a4 = save_a4;
#else
#  define CALLBACK_PROLOGUE
#  define CALLBACK_EPILOGUE
#endif

/*
 * distinguish v1.x from v2.x headers
  */
#ifdef sysAppLaunchCmdHandleSyncCallApp
# define FrmSetObjectPositon FrmSetObjectPosition
# define PrefGetAppPreferences PrefGetAppPreferencesV10
# define PrefSetAppPreferences PrefSetAppPreferencesV10
# define SelectDay(a,b,c,d) SelectDay(selectDayByDay,a,b,c,d)
#endif
  

/*
 * definitions from bl.c
 */

typedef struct {
  UInt Version;
  Short matchDay;
  Short NumTeams;
  Short Spieltage;
} BlDatabasePreferencesType;

typedef struct {
  Int Version;
  LocalID dbID;
  UInt cardNo;
  Byte editMode;
} BlApplicationPreferencesType;

extern char team[20][18];
extern Word programme[380];
extern ULong Datum[38];
extern Short DBNr;
extern SystemPreferencesType sysPrefs;
extern BlApplicationPreferencesType appPrefs;
extern BlDatabasePreferencesType prefs;

typedef struct {
  Byte Tore, GTore, Pkte, Spiele, Platz, HSpiele;
  Byte Gew, HGew, Rem, HRem, Ver, HVer, HTore, HGTore, HPkte;
  UShort Erg[38];
  long Index;
} MannStatus;
extern MannStatus MStatus[];

extern Short matchDay;

VoidPtr Id2Ptr(Word);
void BerechneTabelle();
void FrmMoveObject(Int, Int, Int);
CharPtr M1vSpNr(Word);
CharPtr M2vSpNr(Word);
void DrawBegegnungen(Boolean);
ListPtr FrmGetListPtr(Word frm, Word id);

/*
 * definitions from dbfuncs.c
 */
typedef struct {
  LocalID dbID;
  UInt cardNo;
  Char dbName[32];
  UInt dbAttr;
} SelectedDBInfo;

DmOpenRef CreateDatabase(CharPtr, BlDatabasePreferencesType*);
Err InitDatabase(DmOpenRef, Boolean);
Err OpenDatabase(UInt, LocalID);
void SaveStatus(Short);
Short FindInstalledDatabases();
void ChooseDB();
void SelectedDB(Short, SelectedDBInfo*);
void InitNewDatabase(DmOpenRef);
void DeleteDatabase(Short);
Boolean RenameDatabase(Short i, CharPtr name);

/*
 * definitions from edit.c
 */
void InitFormEdit();
Boolean EditFormHandleEvent(EventPtr);
void InitFormTeams();
Boolean TeamsFormHandleEvent(EventPtr);
Boolean EnterMannFormHandleEvent(EventPtr);
Boolean NewDBFormHandleEvent(EventPtr);
Boolean RenameLeagueFormHandleEvent(EventPtr);
Boolean SettingsFormHandleEvent(EventPtr);

/*
 * extra localization not handled in bl.rcp
 */
#ifdef ENGLISH
#  define CHOOSE_DATE "Choose Date"
#  define H_WON  "W"
#  define H_DRAW "D"
#  define H_LOST "L"
#  define A_WON  "w"
#  define A_DRAW "d"
#  define A_LOST "l"
#else
#  define H_WON  "G"
#  define H_DRAW "U"
#  define H_LOST "V"
#  define A_WON  "g"
#  define A_DRAW "u"
#  define A_LOST "v"
#  define CHOOSE_DATE "Datum whlen"
#endif

#endif
